angular
  .module("starter.controllers")

  .controller(
    "activityDetailCtrl",
    function (
      $scope,
      $state,
      $stateParams,
      $sce,
      $ionicPopup,
      $ionicLoading,
      apiService,
      uiService,
      $ionicTabsDelegate,
      $ionicHistory,
      broadcastService,
      broadcastConstants,
      ngCordovaService
    ) {
      //
      $scope.activity = $stateParams.activity;

      $scope.video_url = undefined;

      //
      $scope.enrollInfo = undefined;
      $scope.queryEnrollStatusByUserId = function () {
        if ($scope.activity && $scope.user) {
          uiService.ionicLoadingShow({
            templateTitle: "正在查看报名状态信息...",
          });
          apiService.queryEnrollStatusByUserId(
            $scope.activity.activityId,
            $scope.user.account,
            {
              onSuccess: function (data, status, config, headers) {
                $scope.enrollInfo = data;
                updateStatusUI($scope.activity, $scope.enrollInfo);
              },
              onError: function (data, status, config, headers) {},
              onFinally: function () {
                $ionicLoading.hide();
              },
            }
          );
        }
      };

      if ($scope.activity) {
        $scope.activity_detail = $sce.trustAsHtml($scope.activity.detail);
        //
        if (ionic.Platform.isIPad() || ionic.Platform.isIOS()) {
          var endTime = new Date($scope.activity.endTime.replace(/-/g, "/"));
        } else {
          var endTime = new Date($scope.activity.endTime);
        }
        var now = new Date();
        if (now.getTime() >= endTime.getTime()) {
          $scope.hasFinished = true;
        } else {
          $scope.hasFinished = false;
        }
        $scope.video_url = $scope.activity.youkuVideo; // 沿用原先的字段名称（之前的视频是来自于优酷）
        /*
            // 测试：视频切换功能
            $scope.video_urls = [
                'http://hc.yinyuetai.com/uploads/videos/common/0CD9014FD94066C00C4B1B637A679473.flv',
                'http://he.yinyuetai.com/uploads/videos/common/604401444DE3D24CC76143100EA75CC2.flv',
                'http://sh.yinyuetai.com/uploads/videos/common/D375015EADC4B4CBE26DF66418CF0F29.mp4',
            ];
            $scope.reloadVideo = function () {
                var index = parseInt(Math.random() * $scope.video_urls.length);
                if (index < 0) {
                    index = 0;
                } else if (index >= $scope.video_urls.length) {
                    index = $scope.video_urls.length - 1;
                }
                var url = $scope.video_urls[index];
                $scope.video_url = url;
            };
            */
        $scope.allowEnrollNumStr =
          $scope.activity.allowEnrollNum == 0
            ? "不限制"
            : $scope.activity.allowEnrollNum + "人";
      }

      // 更新
      $scope.patchActivity = function () {
        $state.go("tab.activityPatch", {
          activity: $scope.activity,
        });
      };
      // 删除
      $scope.deleteActivity = function () {
        $ionicPopup
          .confirm({
            title: "删除活动",
            template: "真的要删除吗？",
            cancelText: "取消",
            okText: "确定",
          })
          .then(function (res) {
            if (res) {
              uiService.ionicLoadingShow({ templateTitle: "正在删除活动..." });
              apiService.deleteActivity(
                $scope.activity.activityId,
                deleteActivityCallback
              );
            }
          });
      };
      var deleteActivityCallback = {
        onSuccess: function (data, status, config, headers) {
          ngCordovaService.showToast("删除当前活动成功");
          $ionicHistory.goBack();
          /***************wsc-change********************/
          // broadcast
          broadcastService.send(broadcastConstants.names.onActivityChanged, {
            operation: "deleteActivity",
            result: "success",
            activity: $scope.activity,
          });
        },
        onError: function (data, status, config, headers) {
          ngCordovaService.showToast("删除当前活动失败");
        },
        onFinally: function () {
          $ionicLoading.hide();
        },
      };

      //
      $scope.source = "app";
      // 成人报名
      $scope.enrollActivity = function () {
        //
        if ($scope.hasFinished) {
          ngCordovaService.showToast("活动已经结束了");
          return;
        }
        //
        if ($scope.user) {
          uiService.ionicLoadingShow({ templateTitle: "正在报名..." });
          apiService.enrollActivitiy(
            {
              activityId: $scope.activity.activityId,
              organizerId: $scope.user.account,
              source: $scope.source,
            },
            enrollActivityCallback
          );
        } else {
          ngCordovaService.showToast("只有已登录用户才能报名");
        }
      };
      //儿童报名
      $scope.showEnrollChildActivityUI_1 = function () {
        if (!$scope.user) {
          ngCordovaService.showToast("只有已登录用户才能报名");
        } else if ($scope.hasFinished) {
          ngCordovaService.showToast("活动已经结束了");
        } else {
          uiService.ionicLoadingShow({ templateTitle: "正在查询子女信息..." });
          apiService.queryChildrenInfoAll($scope.user.account, {
            onSuccess: function (data, status, config, headers) {
              console.log("queryChildrenInfoAllCallback. onSuccess");
              $scope.children = data;
              $scope.showEnrollChildActivityUI_2();
            },
            onError: function (data, status, config, headers) {
              console.warn("queryChildrenInfoAllCallback. onError");
              ngCordovaService.showToast("获取宝贝信息失败，请稍后再试...");
            },
            onFinally: function () {
              // 隐藏进度条
              $ionicLoading.hide().then(function () {
                console.log("The loading indicator is now hidden");
              });
            },
          });
        }
      };
      $scope.showEnrollChildActivityUI_2 = function () {
        if (_.isEmpty($scope.children)) {
          ngCordovaService.showToast("请先到“我的->我的宝贝”中添加您的子女");
        } else {
          // checkbox
          // $scope.checkableChildren = [];
          // $scope.children.forEach(function (child) {
          //     $scope.checkableChildren.push({ child: child, checked: false, });
          // }, this);
          // radio
          $scope.preEnrollInfo = { selectedChildId: undefined };
          var myPopup = $ionicPopup.show({
            templateUrl: "modules/activity/activity_enroll_child_selector.html",
            title: "请选择要报名的子女",
            scope: $scope,
            buttons: [
              {
                text: "取消",
                type: "button-negative",
              },
              {
                text: "报名",
                type: "button-positive",
                onTap: function (e) {
                  // checkbox
                  // $scope.checkedChildren = [];
                  // $scope.checkableChildren.forEach(function (checkableChild) {
                  //     if (checkableChild.checked === true) {
                  //         $scope.checkedChildren.push(checkableChild.child);
                  //     }
                  // }, this);
                  // if (_.isEmpty($scope.checkedChildren)) {
                  //     // ngCordovaService.showToast('请至少选择一位子女'); // checkbox
                  //     e.preventDefault();
                  // }
                  // radio
                  if ($scope.preEnrollInfo.selectedChildId == undefined) {
                    ngCordovaService.showToast("请选择您的一位子女"); // radio
                    e.preventDefault();
                  } else {
                    uiService.ionicLoadingShow({
                      templateTitle: "正在报名...",
                    });
                    // checkbox
                    // var ids = '';
                    // var count = 0;
                    // $scope.checkedChildren.forEach(function (child) {
                    //     if (count > 0) {
                    //         ids += ',';
                    //     }
                    //     ids += child.id;
                    //     count++;
                    // }, this);
                    apiService.enrollActivitiy(
                      {
                        activityId: $scope.activity.activityId,
                        organizerId: $scope.user.account,
                        // childId: ids,                           // checkbox TODO childId，临时使用这个字段表示。后面会更新为其它字段。
                        childId: $scope.preEnrollInfo.selectedChildId, // radio
                        source: $scope.source,
                      },
                      enrollActivityCallback
                    );
                  }
                },
              },
            ],
          });
        }
      };
      var enrollActivityCallback = {
        onSuccess: function (data, status, config, headers) {
          console.log(data);
          if (_.isEmpty(data)) {
            ngCordovaService.showToast("无法解析后台返回的结果");
          } else {
            switch (data.status) {
              case "OK":
                $scope.queryEnrollStatusByUserId();
                ngCordovaService.showToast("报名成功");
                $scope.enrollId = data.id;
                // broadcast
                broadcastService.send(
                  broadcastConstants.names.onActivityChanged,
                  {
                    operation: "enrollActivity",
                    result: "success",
                    activity: $scope.activity,
                  }
                );
                break;
              case "ERROR":
                ngCordovaService.showToast(data.data);
                break;
              default:
                ngCordovaService.showToast("无法解析后台返回的结果");
                break;
            }
          }
        },
        onError: function (data, status, config, headers) {
          ngCordovaService.showToast("报名失败");
        },
        onFinally: function () {
          $ionicLoading.hide();
        },
      };
      // 取消报名
      $scope.unenrollActivity = function (enrollId) {
        $ionicPopup
          .confirm({
            title: "取消报名",
            template: "真的要取消报名吗？",
            cancelText: "取消",
            okText: "确定",
          })
          .then(function (res) {
            if (res) {
              uiService.ionicLoadingShow({ templateTitle: "正在取消报名..." });
              apiService.unenrollActivitiy(enrollId, unenrollActivityCallback);
            }
          });
      };
      var unenrollActivityCallback = {
        onSuccess: function (data, status, config, headers) {
          ngCordovaService.showToast("取消报名成功");
          $scope.enrollId = undefined;
          $scope.queryEnrollStatusByUserId();
          /***************wsc-change********************/
          // broadcast
          broadcastService.send(broadcastConstants.names.onActivityChanged, {
            operation: "unenrollActivity",
            result: "success",
            activity: $scope.activity,
          });
        },
        onError: function (data, status, config, headers) {
          ngCordovaService.showToast("取消报名失败");
        },
        onFinally: function () {
          $ionicLoading.hide();
        },
      };

      // -------------------------------------------------------------
      function updateStatusUI(activity, enrollInfo) {
        if (!activity || !enrollInfo) {
          $scope.canActivityEnrolled = false;
        } else {
          $scope.enrolledChildrenInfo = [];
          if ($scope.hasFinished === true) {
            $scope.canActivityEnrolled = false;
          } else {
            if (_.isEmpty(enrollInfo)) {
              $scope.canActivityEnrolled = true;
            } else if (activity.enrollType) {
              switch (activity.enrollType) {
                case "adult":
                  $scope.canActivityEnrolled = false;
                  $scope.enrollId = enrollInfo[0].id;
                  break;
                case "child":
                  $scope.canActivityEnrolled = true;
                  //
                  enrollInfo.forEach(function (enrolledItem) {
                    if (
                      enrolledItem &&
                      enrolledItem.childInfo &&
                      enrolledItem.enrollStatus
                    ) {
                      var enrollStatus = undefined;
                      switch (enrolledItem.enrollStatus) {
                        case "in_review":
                          enrollStatus = "审核中";
                          break;
                        case "approved":
                          enrollStatus = "审核通过";
                          break;
                        case "unapproved":
                          enrollStatus = "审核未通过";
                          break;
                        default:
                          enrollStatus = ""; // '未知';
                          break;
                      }
                      $scope.enrolledChildrenInfo.push({
                        enrollId: enrolledItem.id,
                        enrollStatus: enrollStatus,
                        childInfo: enrolledItem.childInfo,
                      });
                    }
                  }, this);
                  break;
                default:
                  // $scope.canActivityEnrolled = false;
                  break;
              }
            } else {
              $scope.canActivityEnrolled = false;
            }
          }
        }
      }

      /*****************wsc-change******************/
      //监听和反监听
      var onPatchActivityListener = function (data) {
        //console.log('BookhomeCtrl', angular.toJson(data, true));

        var tmpActivity = data.activity;
        if (tmpActivity) {
          //将毫秒格式转换成正常的格式2012-12-12 12：12：12
          Date.prototype.toLocaleString = function () {
            return (
              this.getFullYear() +
              "-" +
              (this.getMonth() + 1 < 10
                ? "0" + (this.getMonth() + 1)
                : this.getMonth() + 1) +
              "-" +
              (this.getDate() < 10 ? "0" + this.getDate() : this.getDate()) +
              " " +
              (this.getHours() < 10 ? "0" + this.getHours() : this.getHours()) +
              ":" +
              (this.getMinutes() < 10
                ? "0" + this.getMinutes()
                : this.getMinutes()) +
              ":" +
              (this.getSeconds() < 10
                ? "0" + this.getSeconds()
                : this.getSeconds())
            );
          };
          var startTime = new Date(tmpActivity.startTime).toLocaleString();
          var endTime = new Date(tmpActivity.endTime).toLocaleString();

          //
          $scope.activity = tmpActivity;
          $scope.activity.startTime = startTime;
          $scope.activity.endTime = endTime;
          $scope.activity_detail = $sce.trustAsHtml($scope.activity.detail);
        }
      };
      broadcastService.register(
        broadcastConstants.names.onPatchActivity,
        onPatchActivityListener
      ); // 使用同一个listener即可
      $scope.$on("$destroy", function () {
        broadcastService.unregister(
          broadcastConstants.names.onPatchActivity,
          onPatchActivityListener
        );
      });
      // -------------------------------------------------------------------------------
      // 如果当前不清楚报名号，则应当去后台获取一次报名号。
      if ($scope.enrollId == null) {
        // TODO 获取报名号
      }
      $scope.queryEnrollStatusByUserId();
      $ionicTabsDelegate.showBar(false);
    }
  );
