angular
  .module("starter.controllers")

  // 借阅排行榜列表
  .controller(
    "ReturnBookCtrl",
    function (
      $rootScope,
      $scope,
      $cordovaBarcodeScanner,
      $state,
      $stateParams,
      apiService,
      bookService,
      uiService,
      $ionicLoading,
      $ionicHistory,
      $ionicTabsDelegate,
      broadcastService,
      broadcastConstants,
      ngCordovaService,
      appLogService
    ) {
      // ----------------------------------------------------------------------------------------------------------------
      $ionicTabsDelegate.showBar(false);
      $scope.getDefaultInfo = function () {
        apiService.checkReturnDefault({
          onSuccess: function (data, status, config, headers) {
            if (data.status == "OK") {
              $scope.defaultAddress = data.data.city + data.data.address;
              $scope.defaultReceviedTel = data.data.telephone;
            }
          },
        });
      };

      // ----------------------------------------------------------------------------------------------------------------
      $scope.borCodes = $stateParams.borCodes;
      $scope.defaultAddress;
      $scope.defaultReceviedTel;
      $scope.defaultTel;
      if (_.isEmpty(_.trim($rootScope.returnTelephone))) {
        $scope.defaultTel = $scope.user.telephone;
      } else {
        $scope.defaultTel = $rootScope.returnTelephone;
      }

      $scope.getDefaultInfo();
      // // ----------------------------------------------------------------------------------------------------------------
      $scope.data = {
        order: {
          // 自动填写
          accountId: $scope.user.account,
          borrowerId: $scope.user.borrowID,
          borrowerName: $rootScope.userInfo.name,
          expressId: undefined, //快递单号
          barCodes: $scope.borCodes,
          senderName: $scope.user.name,
          senderPhone: $scope.defaultTel,
        },
      };
      // // 创建还书（快递）订单
      $scope.createReturnBookOrder = function () {
        if (
          !$scope.data.order.senderName ||
          _.isEmpty(_.trim($scope.data.order.senderName))
        ) {
          ngCordovaService.showToast("发件人不能为空");
          return;
        }
        if (
          !$scope.data.order.senderPhone ||
          _.isEmpty(_.trim($scope.data.order.senderPhone))
        ) {
          ngCordovaService.showToast("手机号码不能为空");
          return;
        } else if (
          !/^0?(13|14|15|17|18)[0-9]{9}$/.test($scope.data.order.senderPhone)
        ) {
          ngCordovaService.showToast("手机号码格式不正确");
          return;
        }
        $rootScope.returnTelephone = $scope.data.order.senderPhone;
        localStorage.setItem("defaultReturnTel", $scope.data.order.senderPhone);
        if (
          !$scope.data.order.expressId ||
          _.isEmpty(_.trim($scope.data.order.expressId))
        ) {
          ngCordovaService.showToast("快递单号不能为空");
          return;
        } else {
          $scope.data.order.expressId = _.trim($scope.data.order.expressId);
        }
        uiService.ionicLoadingShow({ templateTitle: "正在创建订单..." });
        apiService.createReturnBookOrder($scope.data.order, {
          onSuccess: function (data, status, config, headers) {
            if (data) {
              switch (data.status) {
                case "OK":
                  broadcastService.send(
                    broadcastConstants.names.onCreateReturnBookOrder,
                    {
                      result: "success",
                      loanedBook: $scope.loanedBook,
                      order: $scope.data.order,
                    }
                  );
                  ngCordovaService.showToast("发起还书流程成功");
                  apiService.checkReturnOrders($rootScope.user.borrowID, {
                    onSuccess: function (data, status, config, headers) {
                      if (data) {
                        var amountCount = 0;
                        if (data.returning) {
                          amountCount += parseInt(data.returning);
                        }
                        $rootScope.myReturnOrder = amountCount;
                        if ($rootScope.myReturnOrder == 0) {
                          $rootScope.returnNumberShow = false;
                        } else {
                          $rootScope.returnNumberShow = true;
                        }
                      }
                    },
                  });
                  // $ionicHistory.goBack(); // 现在的规则是不允许在此页面返回
                  break;
                case "ERROR":
                  ngCordovaService.showToast(
                    _.isEmpty(data.data) ? "发起还书流程失败" : data.data
                  ); // data.data描述了订单创建错误的信息
                  //
                  var server_data = data;
                  var module = "createReturnBookOrder";
                  var desciption = "发起还书流程失败";
                  $scope.submitErrorLog(server_data, module, desciption);
                  break;
                case "":
                  ngCordovaService.showToast("已经提交了请求，但是结果未知。");
                  //
                  var server_data = data;
                  var module = "createReturnBookOrder";
                  var desciption = "已经提交了请求，但是结果未知。";
                  $scope.submitErrorLog(server_data, module, desciption);
                  break;
              }
            } else {
              ngCordovaService.showToast("已经提交了请求，但是结果未知。");
              //
              var server_data = data;
              var module = "createReturnBookOrder";
              var desciption = "已经提交了请求，但是结果未知。";
              $scope.submitErrorLog(server_data, module, desciption);
            }
          },
          onError: function (data, status, config, headers) {},
          onFinally: function () {
            $ionicLoading.hide();
            $scope.finish();
          },
        });
      };
      // //扫描二维码
      $scope.scanExpressId = function () {
        $cordovaBarcodeScanner.scan().then(
          function (result) {
            console.log("扫描到订单号：" + result.text);
            $scope.data.order.expressId = result.text;
          },
          function (error) {
            consolog.warn("Scanning failed: " + error);
            ngCordovaService.showToast("摄像头可能正在使用中，请稍后再试...");
          }
        );
      };

      $scope.cancel = function () {
        $ionicHistory.clearHistory();
        $state.go("tab.home");
      };
      $scope.finish = function () {
        $ionicHistory.clearHistory();
        $state.go("tab.mine");
      };

      // // ----------------------------------------------------------------------------------------------------------------
      $scope.submitErrorLog = function (server_data, module, desciption) {
        var log = appLogService.getBaseLog();
        log.level = "warn";
        log.category = "module";
        log.module = module;
        log.error = {
          desciption: desciption,
          actual_data_from_server: angular.toJson(server_data),
        };
        appLogService.uploadLog(log, {
          onSuccess: function (data, status, config, headers) {
            console.log("提交异常日志-->成功");
          },
          onError: function (data, status, config, headers) {
            console.error("提交异常日志-->失败");
          },
          onFinally: function () {
            //
          },
        });
      };
    }
  );
