angular
  .module("starter.controllers")

  .controller(
    "AddressAddCtrl",
    function (
      $rootScope,
      $scope,
      $state,
      $stateParams,
      $ionicTabsDelegate,
      $ionicPopup,
      apiService,
      uiService,
      ngCordovaService,
      $ionicLoading,
      $ionicPopup,
      broadcastConstants,
      broadcastService,
      $ionicHistory
    ) {
      $ionicTabsDelegate.showBar(false);
      $scope.editAdr = $stateParams.address;
      $scope.deteleBtn = false; //控制删除
      $scope.showToggle = true; //控制切换按钮
      $scope.toggleDefault = {}; //切换开关的值
      if ($scope.editAdr.defaultAddress == true) {
        $scope.showToggle = false;
      } else {
        $scope.showToggle = true;
        $scope.toggleDefault.checked = $scope.editAdr.defaultAddress;
      }
      $scope.confirmDefault = function () {
        $scope.toggleValue = $scope.toggleDefault.checked;
      };
      if ($stateParams.title == "选择收货地址") {
        $scope.title = "编辑收货地址";
        $scope.deteleBtn = true;
      } else {
        $scope.title = $stateParams.title;
        $scope.deteleBtn = false;
      }
      $scope.goDelete = function (editAdr) {
        uiService.ionicLoadingShow({ templateTitle: "正在删除..." });
        apiService.deleteAddress(editAdr.id, {
          onSuccess: function (data, status, config, headers) {
            ngCordovaService.showToast("删除地址成功");
            broadcastService.send(
              broadcastConstants.names.addressDelete,
              editAdr
            );
            $ionicHistory.goBack();
          },
          onError: function (data, status, config, headers) {
            ngCordovaService.showToast("删除失败，请稍后尝试");
          },
          onFinally: function () {
            $ionicLoading.hide();
          },
        });
      };
      //新建提交的信息
      $scope.addressInfo = {
        account: $rootScope.userInfo.account,
        receiverName: "", //$scope.editAdr.name,
        province: "",
        city: "",
        district: "",
        address: "", //$scope.editAdr.addressSamll,
        addressType: "home",
        telephone: "", //$scope.editAdr.phone
      };
      //更新的信息
      $scope.updateInfo = {
        id: 0,
        account: $rootScope.userInfo.account,
        receiverName: "",
        province: "",
        city: "",
        district: "",
        address: "",
        addressType: "home",
        telephone: "",
      };
      //城市选择初始化
      var area1 = new LArea();
      var areaParam = {
        trigger: "#demo1", //触发选择控件的文本框，同时选择完毕后name属性输出到该位置
        valueTo: "#value1", //选择完毕后id属性输出到该位置
        keys: {
          id: "id",
          name: "name",
        }, //绑定数据源相关字段 id对应valueTo的value属性输出 name对应trigger的value属性输出
        type: 1, //数据源类型
        data: LAreaData, //数据源
        province: "",
        city: "",
        county: "",
      };
      area1.init(areaParam);
      $scope.address = function () {
        if (_.isEmpty($scope.editAdr.receiverName)) {
          ngCordovaService.showToast("收货人名字不能为空");
          return;
        }
        if (_.isEmpty($scope.editAdr.telephone)) {
          ngCordovaService.showToast("手机号码不能为空");
          return;
        }
        if (!/^0?(13|14|15|17|18)[0-9]{9}$/.test($scope.editAdr.telephone)) {
          ngCordovaService.showToast("手机号码格式错误，请重填");
          return;
        }
        if (
          _.isEmpty($scope.editAdr.address) ||
          $scope.editAdr.address.replace(/(^s*)|(s*$)/g, "").length == 0
        ) {
          ngCordovaService.showToast("请填写详细地址");
          return;
        }
        if (
          _.isEmpty($scope.editAdr.addressBig) ||
          $scope.editAdr.addressBig.replace(/(^s*)|(s*$)/g, "").length == 0
        ) {
          ngCordovaService.showToast("请填写您的所在地区");
          return;
        }
        //新建的信息
        $scope.addressInfo.receiverName = $scope.editAdr.receiverName;
        $scope.addressInfo.telephone = $scope.editAdr.telephone;
        $scope.addressInfo.address = $scope.editAdr.address;
        //更新的信息
        $scope.updateInfo.id = $scope.editAdr.id;
        $scope.updateInfo.receiverName = $scope.editAdr.receiverName;
        $scope.updateInfo.telephone = $scope.editAdr.telephone;
        $scope.updateInfo.address = $scope.editAdr.address;
        if (!areaParam.county) {
          $scope.addressInfo.province = "";
          $scope.addressInfo.city = areaParam.province;
          $scope.addressInfo.district = areaParam.city;

          $scope.updateInfo.province = "";
          $scope.updateInfo.city = areaParam.province;
          $scope.updateInfo.district = areaParam.city;
        } else {
          $scope.addressInfo.province = areaParam.province;
          $scope.addressInfo.city = areaParam.city;
          $scope.addressInfo.district = areaParam.county;

          $scope.updateInfo.province = areaParam.province;
          $scope.updateInfo.city = areaParam.city;
          $scope.updateInfo.district = areaParam.county;
        }
        if (!areaParam.city) {
          $scope.updateInfo.province = $scope.editAdr.province;
          $scope.updateInfo.city = $scope.editAdr.city;
          $scope.updateInfo.district = $scope.editAdr.district;
        }
        if ($scope.title == "新建收货地址") {
          uiService.ionicLoadingShow({ templateTitle: "正在提交..." });
          apiService.addAddress($scope.addressInfo, addAddressCallback);
        } else if ($scope.title == "编辑收货地址") {
          uiService.ionicLoadingShow({ templateTitle: "正在提交..." });
          if ($scope.toggleValue == true) {
            apiService.defaultAddress(
              $rootScope.userInfo.account,
              $scope.editAdr.id,
              {
                onSuccess: function (data, status, config, headers) {
                  apiService.updateAddress(
                    $scope.updateInfo,
                    updateAddressCallback
                  );
                  console.log(data);
                },
                onError: function (data, status, config, headers) {
                  console.log(data);
                },
              }
            );
          } else {
            apiService.updateAddress($scope.updateInfo, updateAddressCallback);
          }
        }
      };
      var addAddressCallback = {
        onSuccess: function (data, status, config, headers) {
          // console.log(data)
          if (data.status == "OK") {
            ngCordovaService.showToast("提交成功");
            $ionicHistory.goBack();
          } else {
            $ionicPopup.alert({
              title: "提交失败",
              template: data.data,
              okText: "确定",
            });
          }
        },
        onError: function (data, status, config, headers) {
          ngCordovaService.showToast("提交失败，请稍后尝试");
        },
        onFinally: function () {
          $ionicLoading.hide();
        },
      };
      var updateAddressCallback = {
        onSuccess: function (data, status, config, headers) {
          if (data.status == "OK") {
            ngCordovaService.showToast("编辑成功");
            $ionicHistory.goBack();
          } else {
            $ionicPopup.alert({
              title: "编辑失败",
              template: data.data,
              okText: "确定",
            });
          }
        },
        onError: function (data, status, config, headers) {
          ngCordovaService.showToast("编辑失败，请稍后尝试");
        },
        onFinally: function () {
          $ionicLoading.hide();
        },
      };
    }
  );
