angular
  .module("starter.controllers")

  .controller(
    "OnlineCommentsCtrl",
    function (
      $scope,
      $ionicSlideBoxDelegate,
      $ionicTabsDelegate,
      $ionicLoading,
      apiService,
      uiService,
      ngCordovaService
    ) {
      // ---------------------------------------------------------------------------------------------------
      $scope.tabNames = ["写意见", "看回复"];
      $scope.slectIndex = 0;
      $scope.activeSlide = function (index) {
        //点击时候触发
        $scope.slectIndex = index;
        $ionicSlideBoxDelegate.slide(index);
      };
      $scope.slideChanged = function (index) {
        //滑动时候触发
        $scope.slectIndex = index;
      };
      $scope.pages = [
        "modules/mine/mine_writecomments.html",
        "modules/mine/mine_checkcomments.html",
      ];
      $ionicTabsDelegate.showBar(false);

      // ---------------------------------------------------------------------------------------------------
      $scope.pageCount = 0;
      $scope.pageSize = 10;
      $scope.sortedColumn = "createTime";
      $scope.comments = [];
      //
      $scope.hasGotAllComments = false;
      $scope.loading = false;

      //
      $scope.reset = function () {
        $scope.pageCount = 0;
        $scope.comments = [];
        $scope.hasGotAllComments = false;
        $scope.loading = false;
      };
      $scope.resetUserMessage = function () {
        // TODO 后台临时要求的格式
        $scope.user_message = {
          title: "",
          summary: "",
          detail: "", // 前台提供
          // createTime: "1487775999585", // 后台可以自动生成
          // alreadRead: true,
          sender: $scope.user.account,
          senderAlias: $scope.user.name,
          // receiver: "admin",           // 后台默认是admin
        };
      };

      // ---------------------------------------------------------------------------------------------------
      // 根据用户id获取用户消息
      $scope.getUserMessage = function () {
        $scope.reset();
        apiService.getUserMessage($scope.user.account, getUserMessageCallback);
      };
      var getUserMessageCallback = {
        onSuccess: function onLoginSuccess(data, status, config, headers) {
          $scope.comments = data;
        },
        onError: function (data, status, hedaers, config) {},
        onFinally: function () {
          $scope.loading = false;
          $scope.hasGotAllComments = true;
        },
      };
      // 根据用户id获取分页的用户消息
      $scope.getUserPageMessage = function () {
        //
        if ($scope.hasGotAllComments) {
          return;
        }
        //
        $scope.loading = true;
        apiService.getUserPageMessage(
          $scope.user.account,
          true,
          $scope.pageCount,
          $scope.pageSize,
          $scope.sortedColumn,
          getUserPageMessageCallback
        );
      };
      var getUserPageMessageCallback = {
        onSuccess: function onLoginSuccess(data, status, config, headers) {
          if (_.isEmpty(data.data)) {
            $scope.hasGotAllComments = true;
          } else {
            //
            if (_.isEmpty($scope.comments)) {
              $scope.comments = [];
            }
            //
            $scope.comments = $scope.comments.concat(data.data);
            //
            $scope.pageCount = $scope.pageCount + 1;
            if ($scope.pageCount == data.totalPages) {
              $scope.hasGotAllComments = true;
            }
          }
        },
        onError: function (data, status, hedaers, config) {},
        onFinally: function () {
          $scope.loading = false;
        },
      };
      // 创建用户消息
      $scope.createUserMessage = function () {
        if ($scope.user_message.detail.length == 0) {
          ngCordovaService.showToast("留言不能为空");
          return;
        }
        uiService.ionicLoadingShow({ templateTitle: "正在提交反馈..." });
        apiService.createUserMessage(
          $scope.user_message,
          createUserMessageCallback
        );
      };
      var createUserMessageCallback = {
        onSuccess: function onLoginSuccess(data, status, config, headers) {
          //
          ngCordovaService.showToast("反馈成功");
          $scope.resetUserMessage();
          //
          $scope.reset();
          $scope.getUserPageMessage();
        },
        onError: function (data, status, hedaers, config) {
          //
          ngCordovaService.showToast("反馈失败");
          //
        },
        onFinally: function () {
          $ionicLoading.hide();
        },
      };

      //
      $scope.refreshComments = function () {
        //
        $scope.reset();
        //
        $scope.hasGotAllComments = false;
        $scope.getUserPageMessage();
      };

      // ---------------------------------------------------------------------------------------------------
      $scope.resetUserMessage();
      $scope.getUserPageMessage();
    }
  );
