angular
  .module("starter.controllers")

  .controller(
    "MyOrderCtrl",
    function (
      $rootScope,
      $scope,
      $ionicSlideBoxDelegate,
      $state,
      $stateParams,
      $ionicPopup,
      $ionicLoading,
      $ionicScrollDelegate,
      apiService,
      uiService,
      $timeout,
      $ionicTabsDelegate,
      broadcastService,
      broadcastConstants,
      $ionicHistory
    ) {
      $scope.statuses = [
        {
          value: "",
          title: "全部",
        },
        {
          value: "packing",
          title: "配货中",
        },
        {
          value: "paying",
          title: "待支付",
        },
        {
          value: "delivering",
          title: "待发货",
        },
        {
          value: "receiving",
          title: "待收货",
        },
        {
          value: "received",
          title: "已完成",
        },
      ];

      $scope.statusMap = {
        packing: "配货中",
        packFailed: "配货失败",
        paying: "待支付",
        payFailed: "支付失败",
        payExit: "支付中断",
        delivering: "待发货",
        picking: "待自提",
        receiving: "待收货",
        closed: "交易关闭",
        exception: "订单异常",
        refund: "已退款",
        refundFail: "退款失败",
        received: "已完成",
      };
      // $scope.tabNames = ['packing', '待支付', '待发货', '待收货', '已完成'];
      $scope.expressState = {
        0: "无轨迹",
        1: "已揽收",
        2: "在途中",
        201: "到达派件城市",
        3: "签收",
        4: "问题件",
      };
      $scope.slectIndex = 0;
      $scope.pages = [
        "modules/order/order_all.html",
        "modules/order/order_packing.html",
        "modules/order/order_need_pay.html",
        "modules/order/order_need_delivery.html",
        "modules/order/order_deliveried.html",
        "modules/order/order_finished.html",
      ];
      //$scope.orders = [];
      $scope.waitSecondsBeforeClose = 3;
      $scope.orderNull = false;
      $scope.ASC = "ASC";
      $scope.DESC = "DESC";
      $scope.slideChanged = function (index) {
        //滑动时候触发
        $scope.slectIndex = index;
        $scope.clearData();
        //获取用户不同状态的订单数量
        apiService.checkAllOrder($rootScope.user.borrowID, {
          onSuccess: function (data, status, config, headers) {
            if (data) {
              var amountCount = 0;
              if (data.packing) {
                amountCount += parseInt(data.packing);
              }
              if (data.paying) {
                amountCount += parseInt(data.paying);
              }
              if (data.delivering) {
                amountCount += parseInt(data.delivering);
              }
              if (data.receiving) {
                amountCount += parseInt(data.receiving);
              }
              if (data.picking) {
                amountCount += parseInt(data.picking);
              }
              $rootScope.myOrderCount = amountCount;
              if ($rootScope.myOrderCount == 0) {
                $rootScope.numberShow = false;
              } else {
                $rootScope.numberShow = true;
              }
            }
          },
        });
        if ($scope.isQueryAuto) {
          uiService.ionicLoadingShow({ templateTitle: "正在查询..." }); //wsc-change
        }
        if (
          $scope.statuses[index].value == "" ||
          $scope.statuses[index].value == "received"
        ) {
          apiService.getOrdersByStatusAndBorrower(
            $scope.user.borrowID,
            $scope.statuses[index].value,
            $scope.page + 1,
            $scope.size,
            $scope.DESC,
            getOrderCallback
          );
        } else {
          apiService.getOrdersByStatusAndBorrower(
            $scope.user.borrowID,
            $scope.statuses[index].value,
            $scope.page + 1,
            $scope.size,
            $scope.ASC,
            getOrderCallback
          );
        }
        //$scope.refresh();
      };
      $scope.activeSlide = function (index) {
        //点击时候触发
        $scope.slectIndex = index;
        $ionicSlideBoxDelegate.slide(index);
        //获取用户不同状态的订单数量
        apiService.checkAllOrder($rootScope.user.borrowID, {
          onSuccess: function (data, status, config, headers) {
            if (data) {
              var amountCount = 0;
              if (data.packing) {
                amountCount += parseInt(data.packing);
              }
              if (data.paying) {
                amountCount += parseInt(data.paying);
              }
              if (data.delivering) {
                amountCount += parseInt(data.delivering);
              }
              if (data.receiving) {
                amountCount += parseInt(data.receiving);
              }
              if (data.picking) {
                amountCount += parseInt(data.picking);
              }
              $rootScope.myOrderCount = amountCount;
              if ($rootScope.myOrderCount == 0) {
                $rootScope.numberShow = false;
              } else {
                $rootScope.numberShow = true;
              }
            }
          },
        });
      };

      //$scope.orders = [];
      $scope.waitSecondsBeforeClose = 3;
      //订单的失败消息
      $scope.refreshFailed = false;
      $scope.refreshFailedMsg = "刷新失败，请重新下拉";
      $scope.loadMoreFailed = false;
      $scope.loadMoreFailedMsg = "加载失败";
      $scope.noMoreBooksMsg = "已经加载所有订单";
      //订单的初始数据
      $scope.orders = [];
      $scope.elementsCount = 0;
      $scope.page = -1;
      $scope.size = 4;
      $scope.totalPages = -1;
      // 重置数据
      $scope.clearData = function () {
        $scope.refreshFailed = false;
        $scope.loadMoreFailed = false;
        $scope.elementsCount = 0;
        $scope.orders = [];
        $scope.totalPages = -1;
        $scope.page = -1;
        $scope.loadStatus == "idel"; // 'idel', 'loading', 'finished:success/failed';
        $ionicScrollDelegate.scrollTop();
      };
      //下拉刷新
      $scope.refresh = function () {
        // 刷新重置数据
        $scope.clearData();
        //
        init();
      };
      // 加载更多
      $scope.loadMore = function (ignoreLoadMoreFailed) {
        if ($scope.refreshFailed) {
          console.warn(
            "加载首页订单，加载下一页只能在之前加载成功的情况下进行。"
          );
          return;
        }
        if ($scope.loadMoreFailed) {
          if (ignoreLoadMoreFailed) {
          } else {
            console.warn(
              "上次加载更多订单失败，加载下一页只能在之前加载成功的情况下进行。"
            );
            return;
          }
        }
        //
        // 只要首页查询成功，page就已经是0了。
        if ($scope.page >= 0 && $scope.page < $scope.totalPages - 1) {
          $scope.loadMoreFailed = false;
          init();
        } else {
          console.warn(
            "查询所有订单列表，当前已经是最后一页，不需要加载下一页。"
          );
        }
      };
      var getOrderCallback = {
        onSuccess: function (data, status, config, headers) {
          if (data) {
            $scope.loadStatus = "success";
            if ($scope.page == -1) {
              // 下拉：首页
              $scope.refreshFailed = false;
            } else {
              // 上拉：原始页码大于等于0
              $scope.loadMoreFailed = false;
            }
            // 查询成功，赋值数据
            $scope.elementsCount = data.elementsCount;
            $scope.totalPages = data.totalPages;
            $scope.page = $scope.page + 1;
            $scope.orders = $scope.orders.concat(data.data);
            if (
              $scope.orders.length == 0 &&
              $scope.statuses[$scope.slectIndex].value == ""
            ) {
              $scope.orderNull = true;
            }
            console.log($scope.orders);
          }
        },
        onError: function (data, status, config, headers) {
          $scope.loadStatus = "failed";
          $ionicPopup.alert({
            title: "当前服务繁忙，请稍后再试",
            okText: "确定",
          });
        },
        /*********wsc-change*********/
        onFinally: function () {
          //
          // 隐藏进度条
          if ($scope.isQueryAuto == true) {
            $scope.$broadcast("scroll.refreshComplete");
          } else {
            $scope.$broadcast("scroll.infiniteScrollComplete");
          }
          if ($scope.isQueryAuto) {
            $scope.isQueryAuto = false;
            $ionicLoading.hide();
          } else {
            if ($scope.page == -1) {
              // 首页查询失败
              $scope.$broadcast("scroll.refreshComplete");
            } else if ($scope.page == 0 && !$scope.refreshFailed) {
              // 首页查询成功
              $scope.$broadcast("scroll.refreshComplete");
            } else if ($scope.page == 0 && $scope.loadMoreFailed) {
              // 第一次更多查询失败
              $scope.$broadcast("scroll.infiniteScrollComplete");
            } else if ($scope.page > 0) {
              // 第n>1次查询更多
              $scope.$broadcast("scroll.infiniteScrollComplete");
            }
          }
        },
      };

      var obtainTraceCallback = {
        onSuccess: function (data, status, config, headers) {
          //console.log(data)
          if (data && data.response) {
            $scope.trace = JSON.parse(data.response);
            $scope.showExpressTrace();
          } else {
            msg = "当前服务繁忙，请稍后再试";
          }
        },
        onError: function (data, status, config, headers) {
          $ionicPopup.alert({
            title: "当前服务繁忙，请稍后再试",
            okText: "确定",
          });
        },
        onFinally: function () {
          // 隐藏进度条
          $ionicLoading.hide().then(function () {
            console.log("The loading indicator is now hidden");
          });
        },
      };

      $scope.showExpressTrace = function () {
        $ionicPopup.show({
          templateUrl: "modules/order/express_trace.html",
          title: "查看物流",
          scope: $scope,
          buttons: [
            {
              text: "<b>确认</b>",
              type: "button-small button-positive",
            },
          ],
        });
      };

      $scope.displayTrace = function () {
        return $scope.trace && $scope.trace.Traces.length > 0;
      };

      var receiverOrderCallback = {
        onSuccess: function (data, status, config, headers) {
          if (data && data.data.orderStatus === "received") {
            $scope.showPopup("签收成功");
            //获取用户不同状态的订单数量
            apiService.checkAllOrder($rootScope.user.borrowID, {
              onSuccess: function (data, status, config, headers) {
                if (data) {
                  var amountCount = 0;
                  if (data.packing) {
                    amountCount += parseInt(data.packing);
                  }
                  if (data.paying) {
                    amountCount += parseInt(data.paying);
                  }
                  if (data.delivering) {
                    amountCount += parseInt(data.delivering);
                  }
                  if (data.receiving) {
                    amountCount += parseInt(data.receiving);
                  }
                  if (data.picking) {
                    amountCount += parseInt(data.picking);
                  }
                  $rootScope.myOrderCount = amountCount;
                  if ($rootScope.myOrderCount == 0) {
                    $rootScope.numberShow = false;
                  } else {
                    $rootScope.numberShow = true;
                  }
                }
              },
            });
          } else {
          }
        },
        onError: function (data, status, config, headers) {
          $ionicPopup.alert({
            title: "当前服务繁忙，请稍后再试",
            okText: "确定",
          });
        },
      };

      var closeOrderCallback = {
        onSuccess: function (data, status, config, headers) {
          console.log(data);
          if (data.status == "OK") {
            if (data && data.data.orderStatus === "closed") {
              $scope.showPopup("交易关闭");
              //获取用户不同状态的订单数量
              apiService.checkAllOrder($rootScope.user.borrowID, {
                onSuccess: function (data, status, config, headers) {
                  if (data) {
                    var amountCount = 0;
                    if (data.packing) {
                      amountCount += parseInt(data.packing);
                    }
                    if (data.paying) {
                      amountCount += parseInt(data.paying);
                    }
                    if (data.delivering) {
                      amountCount += parseInt(data.delivering);
                    }
                    if (data.receiving) {
                      amountCount += parseInt(data.receiving);
                    }
                    if (data.picking) {
                      amountCount += parseInt(data.picking);
                    }
                    $rootScope.myOrderCount = amountCount;
                    if ($rootScope.myOrderCount == 0) {
                      $rootScope.numberShow = false;
                    } else {
                      $rootScope.numberShow = true;
                    }
                  }
                },
              });
            } else {
            }
          } else {
            $ionicPopup.alert({
              title: data.data,
              okText: "确定",
            });
          }
        },
        onError: function (data, status, config, headers) {
          $ionicPopup.alert({
            title: "当前服务繁忙，请稍后再试",
            okText: "确定",
          });
        },
      };

      $scope.showPopup = function (title) {
        var modal = $ionicPopup.show({
          template:
            '<div class="card"><div class="item item-text-wrap">窗口将在<timer interval="1000" countdown="waitSecondsBeforeClose">{{countdown}}</timer>s后自动关闭</div></div>',
          title: title,
          scope: $scope,
          buttons: [
            {
              text: "<b>确认</b>",
              type: "button-small button-positive",
            },
          ],
        });

        $timeout(function () {
          modal.close();
          $scope.clearData();
          if (
            $scope.statuses[$scope.slectIndex].value == "" ||
            $scope.statuses[$scope.slectIndex].value == "received"
          ) {
            apiService.getOrdersByStatusAndBorrower(
              $rootScope.user.borrowID,
              $scope.statuses[$scope.slectIndex].value,
              $scope.page + 1,
              $scope.size,
              $scope.DESC,
              getOrderCallback
            );
          } else {
            apiService.getOrdersByStatusAndBorrower(
              $rootScope.user.borrowID,
              $scope.statuses[$scope.slectIndex].value,
              $scope.page + 1,
              $scope.size,
              $scope.ASC,
              getOrderCallback
            );
          }
        }, $scope.waitSecondsBeforeClose * 1000);
      };

      $scope.obtainTrace = function (expressId) {
        uiService.ionicLoadingShow({ templateTitle: "正在查询..." });
        apiService.obtainTraceByExpressId(expressId, obtainTraceCallback);
      };

      $scope.receiveOrder = function (orderid) {
        apiService.receiverOrder(orderid, receiverOrderCallback);
      };

      $scope.closeOrder = function (orderid) {
        //console.log(orderid)
        apiService.closeOrder(orderid, closeOrderCallback);
      };
      $scope.myGoBack = function () {
        $ionicHistory.goBack();
      };

      function init() {
        if ($scope.loadStatus == "loading" || $scope.loadStatus == "failed") {
          console.warn(
            "load page " + ($scope.page + 1) + " unfinished, waitting please..."
          );
          return;
        }
        if ($scope.slectIndex != undefined && !isNaN($scope.slectIndex)) {
          //
        } else {
          // var index = _.indexOf($scope.tabNames, $stateParams.to);
          var index = -1;
          for (var i in $scope.statuses) {
            var status = $scope.statuses;
            if (!_.isEmpty(status)) {
              if ($stateParams.to == status.title) {
                index = i;
                break;
              }
            }
          }
          $scope.slectIndex = index === -1 ? 0 : index;
        }
        //获取用户不同状态的订单数量
        apiService.checkAllOrder($rootScope.user.borrowID, {
          onSuccess: function (data, status, config, headers) {
            if (data) {
              var amountCount = 0;
              if (data.packing) {
                amountCount += parseInt(data.packing);
              }
              if (data.paying) {
                amountCount += parseInt(data.paying);
              }
              if (data.delivering) {
                amountCount += parseInt(data.delivering);
              }
              if (data.receiving) {
                amountCount += parseInt(data.receiving);
              }
              if (data.picking) {
                amountCount += parseInt(data.picking);
              }
              $rootScope.myOrderCount = amountCount;
            }
          },
        });
        $scope.loadStatus = "loading";
        if ($scope.isQueryAuto) {
          uiService.ionicLoadingShow({ templateTitle: "正在查询..." }); //wsc-change
        }
        if (
          $scope.statuses[$scope.slectIndex].value == "" ||
          $scope.statuses[$scope.slectIndex].value == "received"
        ) {
          apiService.getOrdersByStatusAndBorrower(
            $rootScope.user.borrowID,
            $scope.statuses[$scope.slectIndex].value,
            $scope.page + 1,
            $scope.size,
            $scope.DESC,
            getOrderCallback
          );
        } else {
          apiService.getOrdersByStatusAndBorrower(
            $rootScope.user.borrowID,
            $scope.statuses[$scope.slectIndex].value,
            $scope.page + 1,
            $scope.size,
            $scope.ASC,
            getOrderCallback
          );
        }
      }

      // -------------------------------------------------------------------------------------------------

      $scope.currentState = $ionicHistory.currentStateName();
      if ($scope.currentState == "tab.homemyorder") {
        $scope.goOrderDetail = function (order) {
          $state.go("tab.homeorder_detail", { order: order });
        };
        $scope.payOrder = function (order) {
          $state.go("tab.payconfirm", { order: order });
        };
      } else if ($scope.currentState == "tab.myorder") {
        $scope.goOrderDetail = function (order) {
          $state.go("tab.order_detail", { order: order });
        };
        $scope.payOrder = function (order) {
          $state.go("tab.minepayconfirm", { order: order });
        };
      } else if ($scope.currentState == "tab.discoverymyorder") {
        $scope.goOrderDetail = function (order) {
          $state.go("tab.discoveryorder_detail", { order: order });
        };
        $scope.payOrder = function (order) {
          $state.go("tab.discoverypayconfirm", { order: order });
        };
      } else {
        $scope.goOrderDetail = function (order) {
          $state.go("tab.bookhomeorder_detail", { order: order });
        };
        $scope.payOrder = function (order) {
          $state.go("tab.bookhomepayconfirm", { order: order });
        };
      }
      /******************wsc-change*********************/
      //监听和反监听
      var onPayConfirmBookChangedListener = function () {
        //console.log('BookhomeCtrl', angular.toJson(data, true));
        $scope.refresh();
      };
      broadcastService.register(
        broadcastConstants.names.onPayConfirmBookChanged,
        onPayConfirmBookChangedListener
      );
      $scope.$on("$destroy", function () {
        broadcastService.unregister(
          broadcastConstants.names.onPayConfirmBookChanged,
          onPayConfirmBookChangedListener
        );
      });
      $scope.isQueryAuto = true;
      $scope.refresh();

      $ionicTabsDelegate.showBar(false);
    }
  );
