angular
  .module("starter.controllers")

  .controller(
    "OrderDetailCtrl",
    function (
      $scope,
      $state,
      $stateParams,
      $ionicHistory,
      $ionicTabsDelegate,
      apiService,
      uiService,
      ngCordovaService,
      $ionicLoading,
      $ionicPopup
    ) {
      //
      $scope.expressState = {
        0: "无轨迹",
        1: "已揽收",
        2: "在途中",
        201: "到达派件城市",
        3: "签收",
        4: "问题件",
      };
      //
      $ionicTabsDelegate.showBar(false);
      $scope.statusMap = {
        packing: "配货中",
        packFailed: "配货失败",
        paying: "待支付",
        payFailed: "支付失败",
        payExit: "支付中断",
        delivering: "待发货",
        picking: "待自提",
        receiving: "待收货",
        closed: "交易关闭",
        exception: "订单异常",
        refund: "已退款",
        refundFail: "退款失败",
        received: "已完成",
      };
      $scope.borrowStatus = {
        notAllowed: "暂不可借",
        borrowing: "正在借阅",
        borrowed: "借阅成功",
        borrowFailed: "借阅失败",
        returning: "归还中",
        returned: "归还成功",
        returnFailed: "归还失败",
        autoReturnedByCancelOrder: "取消订单归还",
        autoReturnedByUnpay: "未支付归还",
        autoReturnedByUnpickup: "未自取归还",
        autoReturnedByPackFailed: "配货失败归还",
      };
      $scope.typesMap = {
        express: "快递",
        pickup: "自取",
      };

      //
      $scope.orderObject = $stateParams.order;
      function init() {
        apiService.findOrderDetail(
          $scope.orderObject.order.orderId,
          findOrderDetailCallback
        );
      }
      var findOrderDetailCallback = {
        onSuccess: function (data, status, config, headers) {
          if (data) {
            $scope.order = data;
          }
        },
      };
      init();
      // ------------------------------------------------------------------------------------------------------
      // 取消订单
      $scope.closeOrder = function (orderid) {
        apiService.closeOrder(orderid, closeOrderCallback);
      };
      var closeOrderCallback = {
        onSuccess: function (data, status, config, headers) {
          if (data && data.status === "交易关闭") {
            console.log("订单已被取消");
            ngCordovaService.showToast("取消订单成功");
            $ionicHistory.goBack();
          } else {
            console.warn("取消订单失败");
            ngCordovaService.showToast("取消订单失败");
          }
        },
        onError: function (data, status, config, headers) {
          console.warn("取消订单发生未知异常");
          ngCordovaService.showToast("取消订单失败");
        },
        onFinally: function () {},
      };

      // ------------------------------------------------------------------------------------------------------
      // 支付订单
      $scope.payOrder = function (orderid) {
        $state.go("tab.minepayconfirm", { orderId: orderid });
      };

      // ------------------------------------------------------------------------------------------------------
      // 查看订单
      $scope.obtainTrace = function (expressId) {
        uiService.ionicLoadingShow({ templateTitle: "正在查询..." });
        apiService.obtainTraceByExpressId(expressId, obtainTraceCallback);
      };
      var obtainTraceCallback = {
        onSuccess: function (data, status, config, headers) {
          if (data && data.response) {
            $scope.trace = JSON.parse(data.response);
            console.log("订单跟踪：" + $scope.trace);
            $scope.showExpressTrace();
          } else {
            console.warn("查询订单出现未知错误");
            ngCordovaService.showToast("查询物流信息失败");
          }
        },
        onError: function (data, status, config, headers) {
          console.warn("查询订单出现未知错误");
          ngCordovaService.showToast("查询物流信息失败");
        },
        onFinally: function () {
          // 隐藏进度条
          $ionicLoading.hide().then(function () {
            console.log("The loading indicator is now hidden");
          });
        },
      };
      $scope.showExpressTrace = function () {
        $ionicPopup.show({
          templateUrl: "modules/order/express_trace.html",
          title: "查看物流",
          scope: $scope,
          buttons: [
            {
              text: "<b>确认</b>",
              type: "button-small button-positive",
            },
          ],
        });
      };
      $scope.displayTrace = function () {
        return $scope.trace && $scope.trace.Traces.length > 0;
      };

      // ------------------------------------------------------------------------------------------------------
      // 确认收货
      $scope.receiveOrder = function (orderid) {
        apiService.receiverOrder(orderid, receiverOrderCallback);
      };
      var receiverOrderCallback = {
        onSuccess: function (data, status, config, headers) {
          if (data && data.status === "已完成") {
            console.log("签收成功");
            ngCordovaService.showToast("签收成功");
            $ionicHistory.goBack();
          } else {
            console.warn("签收失败");
            ngCordovaService.showToast("签收失败");
          }
        },
        onError: function (data, status, config, headers) {
          console.warn("签收失败");
          ngCordovaService.showToast("签收失败");
        },
      };
    }
  );
